
clear
clf


%file=fopen("sh.d","r");
file=fopen("crocodile512.d","r");
X=fscanf(file,'%f',[2 Inf]);
fclose(file);


X2=X;


%subdivision
Nd=4;
save_x=cell(Nd,1);
save_y=cell(Nd,1);
for(k=1:Nd)
  [X2,Y2]=subdivide_chaikin_multires(X2);
  save_x(k)=X2;
  save_y(k)=Y2;
end

%hierarchical deformation
X2(2,1)=X2(2,1)-1.5;                    
X2(1,1)=X2(1,1)+4;

X2(2,2)=X2(2,2)-1.3;
X2(1,2)=X2(1,2)+1;

X2(2,end)=X2(2,end)-2;
X2(1,end)=X2(1,end)+2;

X2(2,end-1)=X2(2,end-1)-0.7;
X2(1,end-1)=X2(1,end-1)+0;

u = X2;


%rebuild
for(k=1:Nd)
  X2 = rebuild_chaikin_multires(X2,save_y{Nd-k+1});
end

%draw
hold on
plot([X2(1,:),X2(1,1)],[X2(2,:),X2(2,1)],"r","linewidth",2);
plot(u(1,:),u(2,:),"b+","markersize",1,"linewidth",2);

axis square

axis([0,10,0,9]);

%print -dpng "reconstruction_croco_0.png"